#include "TessViewer_main.h"

//---------------------
//----    SCENE    ----
//---------------------

/// Reloads all shaders
void reload_shaders()
{
	IL_FOS_program.Init();
	IL_FOS_program.AddVertexShader("Shaders/vertex.glsl");
	IL_FOS_program.AddTessControlShader("Shaders/IL_tess_control.glsl");
	IL_FOS_program.AddTessEvaluationShader("Shaders/IL_FOS_tess_eval.glsl");
	IL_FOS_program.AddFragmentShader("Shaders/fragment.glsl");
	IL_FOS_program.Link();
	IL_FOS_PM_program.Init();
	IL_FOS_PM_program.AddVertexShader("Shaders/vertex.glsl");
	IL_FOS_PM_program.AddTessControlShader("Shaders/IL_tess_control.glsl");
	IL_FOS_PM_program.AddTessEvaluationShader("Shaders/IL_FOS_PM_tess_eval.glsl");
	IL_FOS_PM_program.AddFragmentShader("Shaders/fragment.glsl");
	IL_FOS_PM_program.Link();

	IL_FES_program.Init();
	IL_FES_program.AddVertexShader("Shaders/vertex.glsl");
	IL_FES_program.AddTessControlShader("Shaders/IL_tess_control.glsl");
	IL_FES_program.AddTessEvaluationShader("Shaders/IL_FES_tess_eval.glsl");
	IL_FES_program.AddFragmentShader("Shaders/fragment.glsl");
	IL_FES_program.Link();
	IL_FES_PM_program.Init();
	IL_FES_PM_program.AddVertexShader("Shaders/vertex.glsl");
	IL_FES_PM_program.AddTessControlShader("Shaders/IL_tess_control.glsl");
	IL_FES_PM_program.AddTessEvaluationShader("Shaders/IL_FES_PM_tess_eval.glsl");
	IL_FES_PM_program.AddFragmentShader("Shaders/fragment.glsl");
	IL_FES_PM_program.Link();

	IL_ES_program.Init();
	IL_ES_program.AddVertexShader("Shaders/vertex.glsl");
	IL_ES_program.AddTessControlShader("Shaders/IL_tess_control.glsl");
	IL_ES_program.AddTessEvaluationShader("Shaders/IL_ES_tess_eval.glsl");
	IL_ES_program.AddFragmentShader("Shaders/fragment.glsl");
	IL_ES_program.Link();
	IL_ES_PM_program.Init();
	IL_ES_PM_program.AddVertexShader("Shaders/vertex.glsl");
	IL_ES_PM_program.AddTessControlShader("Shaders/IL_tess_control.glsl");
	IL_ES_PM_program.AddTessEvaluationShader("Shaders/IL_ES_PM_tess_eval.glsl");
	IL_ES_PM_program.AddFragmentShader("Shaders/fragment.glsl");
	IL_ES_PM_program.Link();

	T_FOS_program.Init();
	T_FOS_program.AddVertexShader("Shaders/vertex.glsl");
	T_FOS_program.AddTessControlShader("Shaders/T_tess_control.glsl");
	T_FOS_program.AddTessEvaluationShader("Shaders/T_FOS_tess_eval.glsl");
	T_FOS_program.AddFragmentShader("Shaders/fragment.glsl");
	T_FOS_program.Link();
	T_FOS_PM_program.Init();
	T_FOS_PM_program.AddVertexShader("Shaders/vertex.glsl");
	T_FOS_PM_program.AddTessControlShader("Shaders/T_tess_control.glsl");
	T_FOS_PM_program.AddTessEvaluationShader("Shaders/T_FOS_PM_tess_eval.glsl");
	T_FOS_PM_program.AddFragmentShader("Shaders/fragment.glsl");
	T_FOS_PM_program.Link();

	T_FES_program.Init();
	T_FES_program.AddVertexShader("Shaders/vertex.glsl");
	T_FES_program.AddTessControlShader("Shaders/T_tess_control.glsl");
	T_FES_program.AddTessEvaluationShader("Shaders/T_FES_tess_eval.glsl");
	T_FES_program.AddFragmentShader("Shaders/fragment.glsl");
	T_FES_program.Link();
	T_FES_PM_program.Init();
	T_FES_PM_program.AddVertexShader("Shaders/vertex.glsl");
	T_FES_PM_program.AddTessControlShader("Shaders/T_tess_control.glsl");
	T_FES_PM_program.AddTessEvaluationShader("Shaders/T_FES_PM_tess_eval.glsl");
	T_FES_PM_program.AddFragmentShader("Shaders/fragment.glsl");
	T_FES_PM_program.Link();

	T_ES_program.Init();
	T_ES_program.AddVertexShader("Shaders/vertex.glsl");
	T_ES_program.AddTessControlShader("Shaders/T_tess_control.glsl");
	T_ES_program.AddTessEvaluationShader("Shaders/T_ES_tess_eval.glsl");
	T_ES_program.AddFragmentShader("Shaders/fragment.glsl");
	T_ES_program.Link();
	T_ES_PM_program.Init();
	T_ES_PM_program.AddVertexShader("Shaders/vertex.glsl");
	T_ES_PM_program.AddTessControlShader("Shaders/T_tess_control.glsl");
	T_ES_PM_program.AddTessEvaluationShader("Shaders/T_ES_PM_tess_eval.glsl");
	T_ES_PM_program.AddFragmentShader("Shaders/fragment.glsl");
	T_ES_PM_program.Link();

	Q_FOS_program.Init();
	Q_FOS_program.AddVertexShader("Shaders/vertex.glsl");
	Q_FOS_program.AddTessControlShader("Shaders/Q_tess_control.glsl");
	Q_FOS_program.AddTessEvaluationShader("Shaders/Q_FOS_tess_eval.glsl");
	Q_FOS_program.AddFragmentShader("Shaders/fragment.glsl");
	Q_FOS_program.Link();
	Q_FOS_PM_program.Init();
	Q_FOS_PM_program.AddVertexShader("Shaders/vertex.glsl");
	Q_FOS_PM_program.AddTessControlShader("Shaders/Q_tess_control.glsl");
	Q_FOS_PM_program.AddTessEvaluationShader("Shaders/Q_FOS_PM_tess_eval.glsl");
	Q_FOS_PM_program.AddFragmentShader("Shaders/fragment.glsl");
	Q_FOS_PM_program.Link();

	Q_FES_program.Init();
	Q_FES_program.AddVertexShader("Shaders/vertex.glsl");
	Q_FES_program.AddTessControlShader("Shaders/Q_tess_control.glsl");
	Q_FES_program.AddTessEvaluationShader("Shaders/Q_FES_tess_eval.glsl");
	Q_FES_program.AddFragmentShader("Shaders/fragment.glsl");
	Q_FES_program.Link();
	Q_FES_PM_program.Init();
	Q_FES_PM_program.AddVertexShader("Shaders/vertex.glsl");
	Q_FES_PM_program.AddTessControlShader("Shaders/Q_tess_control.glsl");
	Q_FES_PM_program.AddTessEvaluationShader("Shaders/Q_FES_PM_tess_eval.glsl");
	Q_FES_PM_program.AddFragmentShader("Shaders/fragment.glsl");
	Q_FES_PM_program.Link();

	Q_ES_program.Init();
	Q_ES_program.AddVertexShader("Shaders/vertex.glsl");
	Q_ES_program.AddTessControlShader("Shaders/Q_tess_control.glsl");
	Q_ES_program.AddTessEvaluationShader("Shaders/Q_ES_tess_eval.glsl");
	Q_ES_program.AddFragmentShader("Shaders/fragment.glsl");
	Q_ES_program.Link();
	Q_ES_PM_program.Init();
	Q_ES_PM_program.AddVertexShader("Shaders/vertex.glsl");
	Q_ES_PM_program.AddTessControlShader("Shaders/Q_tess_control.glsl");
	Q_ES_PM_program.AddTessEvaluationShader("Shaders/Q_ES_PM_tess_eval.glsl");
	Q_ES_PM_program.AddFragmentShader("Shaders/fragment.glsl");
	Q_ES_PM_program.Link();

	cout << "Shaders are reloaded" << endl;
}

/// Initializes all objects of our scene
void init_scene()
{
	//----------------------------------------------
	//--  Display some information about the OpenGL

	PrintOpenGLInfo();

	//----------------------------------------------
	//--  Load shaders

	reload_shaders();

	//----------------------------------------------
	//--  Create VAO

	glGenVertexArrays(1, &empty_vao);
	glBindVertexArray(empty_vao);
	glBindVertexArray(0);
}

/// Updates the scene: performs animations, updates the data of the buffers, etc.
void update_scene(int app_time_diff_ms)
{
}

/// Renders the whole frame
void render_scene()
{
	// Render into the main window
	glBindFramebuffer(GL_FRAMEBUFFER, 0);
	glViewport(0, 0, win_width, win_height);

	// Clear the framebuffer
	glClearColor(1.0f, 1.0f, 1.0f, 1.0f);
	glClear(GL_COLOR_BUFFER_BIT);

	ShaderProgram *current_program = nullptr;
	if ((primitives == PRIMITIVE_ISOLINES)	&& (spacing == FRACTIONAL_ODD_SPACING)	&& !point_mode)		current_program = &IL_FOS_program;
	if ((primitives == PRIMITIVE_ISOLINES)	&& (spacing == FRACTIONAL_ODD_SPACING)	&& point_mode)		current_program = &IL_FOS_PM_program;
	if ((primitives == PRIMITIVE_ISOLINES)	&& (spacing == FRACTIONAL_EVEN_SPACING)	&& !point_mode)		current_program = &IL_FES_program;
	if ((primitives == PRIMITIVE_ISOLINES)	&& (spacing == FRACTIONAL_EVEN_SPACING)	&& point_mode)		current_program = &IL_FES_PM_program;
	if ((primitives == PRIMITIVE_ISOLINES)	&& (spacing == EQUAL_SPACING)			&& !point_mode)		current_program = &IL_ES_program;
	if ((primitives == PRIMITIVE_ISOLINES)	&& (spacing == EQUAL_SPACING)			&& point_mode)		current_program = &IL_ES_PM_program;
	if ((primitives == PRIMITIVE_TRIANGLES)	&& (spacing == FRACTIONAL_ODD_SPACING)	&& !point_mode)		current_program = &T_FOS_program;
	if ((primitives == PRIMITIVE_TRIANGLES)	&& (spacing == FRACTIONAL_ODD_SPACING)	&& point_mode)		current_program = &T_FOS_PM_program;
	if ((primitives == PRIMITIVE_TRIANGLES)	&& (spacing == FRACTIONAL_EVEN_SPACING)	&& !point_mode)		current_program = &T_FES_program;
	if ((primitives == PRIMITIVE_TRIANGLES)	&& (spacing == FRACTIONAL_EVEN_SPACING)	&& point_mode)		current_program = &T_FES_PM_program;
	if ((primitives == PRIMITIVE_TRIANGLES)	&& (spacing == EQUAL_SPACING)			&& !point_mode)		current_program = &T_ES_program;
	if ((primitives == PRIMITIVE_TRIANGLES)	&& (spacing == EQUAL_SPACING)			&& point_mode)		current_program = &T_ES_PM_program;
	if ((primitives == PRIMITIVE_QUADS)		&& (spacing == FRACTIONAL_ODD_SPACING)	&& !point_mode)		current_program = &Q_FOS_program;
	if ((primitives == PRIMITIVE_QUADS)		&& (spacing == FRACTIONAL_ODD_SPACING)	&& point_mode)		current_program = &Q_FOS_PM_program;
	if ((primitives == PRIMITIVE_QUADS)		&& (spacing == FRACTIONAL_EVEN_SPACING)	&& !point_mode)		current_program = &Q_FES_program;
	if ((primitives == PRIMITIVE_QUADS)		&& (spacing == FRACTIONAL_EVEN_SPACING)	&& point_mode)		current_program = &Q_FES_PM_program;
	if ((primitives == PRIMITIVE_QUADS)		&& (spacing == EQUAL_SPACING)			&& !point_mode)		current_program = &Q_ES_program;
	if ((primitives == PRIMITIVE_QUADS)		&& (spacing == EQUAL_SPACING)			&& point_mode)		current_program = &Q_ES_PM_program;
	
	if (current_program && current_program->IsValid())
	{
		current_program->Use();
		current_program->Uniform1f("TessLevelInner[0]", TessLevelInner[0]);
		current_program->Uniform1f("TessLevelInner[1]", TessLevelInner[1]);
		current_program->Uniform1f("TessLevelOuter[0]", TessLevelOuter[0]);
		current_program->Uniform1f("TessLevelOuter[1]", TessLevelOuter[1]);
		current_program->Uniform1f("TessLevelOuter[2]", TessLevelOuter[2]);
		current_program->Uniform1f("TessLevelOuter[3]", TessLevelOuter[3]);

		glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);		// Always in wireframe
		glPointSize(3.0f);

		glBindVertexArray(empty_vao);
		glPatchParameteri(GL_PATCH_VERTICES, 1);
		glDrawArrays(GL_PATCHES, 0, 1);
	}

	// Reset the VAO and the program
	glBindVertexArray(0);
	glUseProgram(0);
	glBindFramebuffer(GL_FRAMEBUFFER, 0);
	glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
}

//-------------------
//----    GUI    ----
//-------------------

/// Callback when user clicks on Reload button
void TW_CALL reload(void *)
{
	reload_shaders();
}

void init_gui()
{
	primitives = PRIMITIVE_QUADS;
	spacing = EQUAL_SPACING;
	point_mode = false;

	TessLevelInner[0] = 10.0f;
	TessLevelInner[1] = 10.0f;
	TessLevelOuter[0] = 10.0f;
	TessLevelOuter[1] = 10.0f;
	TessLevelOuter[2] = 10.0f;
	TessLevelOuter[3] = 10.0f;

	// Initialize AntTweakBar
	TwInit(TW_OPENGL_CORE, nullptr);
	TwWindowSize(win_width, win_height);
	TwGLUTModifiersFunc(glutGetModifiers);

	// Initialize GUI
	the_gui = TwNewBar("Parameters");
	TwAddButton(the_gui, "Reload", reload, nullptr, nullptr);

	// Primitives
	TwEnumVal primitives_t[3] = {
		{PRIMITIVE_ISOLINES, "isolines"},
		{PRIMITIVE_QUADS, "quads"},
		{PRIMITIVE_TRIANGLES, "triangles"},
	};
	TwType primitivesType = TwDefineEnum("Primitives", primitives_t, 3);
	TwAddVarRW(the_gui, "Primitive", primitivesType, &primitives, nullptr);

	// Spacing
	TwEnumVal spacing_t[3] = {
		{EQUAL_SPACING, "equal spacing"},
		{FRACTIONAL_EVEN_SPACING, "fractional even spacing"},
		{FRACTIONAL_ODD_SPACING, "fractional odd spacing"},
	};
	TwType spacingType = TwDefineEnum("Spacings", spacing_t, 3);
	TwAddVarRW(the_gui, "Spacing", spacingType, &spacing, nullptr);

	TwAddVarRW(the_gui, "Point mode", TW_TYPE_BOOLCPP, &point_mode, nullptr);

	TwAddVarRW(the_gui, "TessLevelInner[0]", TW_TYPE_FLOAT, &TessLevelInner[0], "min=0 max=64 step=0.1");
	TwAddVarRW(the_gui, "TessLevelInner[1]", TW_TYPE_FLOAT, &TessLevelInner[1], "min=0 max=64 step=0.1");
	TwAddVarRW(the_gui, "TessLevelOuter[0]", TW_TYPE_FLOAT, &TessLevelOuter[0], "min=0 max=64 step=0.1");
	TwAddVarRW(the_gui, "TessLevelOuter[1]", TW_TYPE_FLOAT, &TessLevelOuter[1], "min=0 max=64 step=0.1");
	TwAddVarRW(the_gui, "TessLevelOuter[2]", TW_TYPE_FLOAT, &TessLevelOuter[2], "min=0 max=64 step=0.1");
	TwAddVarRW(the_gui, "TessLevelOuter[3]", TW_TYPE_FLOAT, &TessLevelOuter[3], "min=0 max=64 step=0.1");
}

//---------------------------
//----    APPLICATION    ----
//---------------------------

/// GLUT callback - when the user presses a key. See glutKeyboardFunc for more info
void on_keyboard_func(unsigned char key, int x, int y)
{
	// Inform AntTweakBar
	if (TwEventKeyboardGLUT(key, x, y))
		return;		// Already handled by AntTweakBar

	switch (key)
	{
	case 27:		// Escape key
		exit(0);
		break;
	}
}

/// GLUT callback - when the user presses a special key (like F1 key). See glutSpecialFunc for more info
void on_special_func(int key, int x, int y)
{
	// Inform AntTweakBar
	if (TwEventSpecialGLUT(key, x, y))
		return;		// Already handled by AntTweakBar
}

/// GLUT callback - when the user presses or releases a mouse button. See glutMouseFunc for more info
void on_mouse_func(int button, int state, int x, int y)
{
	// Inform AntTweakBar
	if (TwEventMouseButtonGLUT(button, state, x, y))
		return;		// Already handled by AntTweakBar
}

/// GLUT callback - when the user moves the mouse when holding a botton. See glutMotionFunc for more info
void on_motion_func(int x, int y)
{
	// Inform AntTweakBar
	if (TwEventMouseMotionGLUT(x, y))
		return;		// Already handled by AntTweakBar
}

/// GLUT callback - when the user moves the mouse when not holding a botton. See glutPassiveMotionFunc for more info
void on_passive_motion_func(int x, int y)
{
	// Inform AntTweakBar
	if (TwEventMouseMotionGLUT(x, y))
		return;		// Already handled by AntTweakBar
}

/// GLUT callback - when the window is resized. See glutReshapeFunc for more info
void on_reshape(int width, int height)
{
	win_width = width;
	win_height = height;
	
	glViewport(0, 0, win_width, win_height);
	
	// Inform AntTweakBar
	TwWindowSize(win_width, win_height);
}

/// GLUT callback - when our animation timer requests a new frame. See glutTimerFunc for more info
void on_timer(int)
{
	// Register the timer to be called again in 20 ms, and rerender the scene
	glutTimerFunc(20, on_timer, 0);
	glutPostRedisplay();
}

/// GLUT callback - when the window needs to be redrawn. See glutDisplayFunc for more info
void on_display()
{
	//--  Update all the data

	// Update the application time
	int current_glut_time = glutGet(GLUT_ELAPSED_TIME);
	int app_time_diff_ms = current_glut_time - last_glut_time;
	app_time_ms += app_time_diff_ms;
	last_glut_time = current_glut_time;

	// Update the scene
	update_scene(app_time_diff_ms);

	//--  Render the scene

	// Render the scene
	render_scene();
	
	// Render the GUI
	TwDraw();

	// Swaps the front and back buffer (double-buffering)
	glutSwapBuffers();
}

/// Callback function to be called when we make an error in OpenGL
void GLAPIENTRY simple_debug_callback(GLenum source, GLenum type, GLuint id, GLenum severity, GLsizei length, const char* message, const void* userParam)
{
	switch (type)			// Report only some errors
	{
	case GL_DEBUG_TYPE_ERROR:
	case GL_DEBUG_TYPE_DEPRECATED_BEHAVIOR:
	case GL_DEBUG_TYPE_UNDEFINED_BEHAVIOR:
		cout << message << endl;		// Put the breakpoint here
		return;
	default:
		return;
	}
}

/// C main function :-)
int main(int argc, char ** argv)
{
	// Initialize GLUT
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DEPTH | GLUT_DOUBLE | GLUT_RGBA);
	glutSetOption(GLUT_ACTION_ON_WINDOW_CLOSE, GLUT_ACTION_GLUTMAINLOOP_RETURNS);		// Return from the main loop

	// Set OpenGL Context parameters
	glutInitContextVersion(4, 0);				// Use OpenGL 4.0
	glutInitContextProfile(GLUT_CORE_PROFILE);	// Use OpenGL core profile
	glutInitContextFlags(GLUT_DEBUG);			// Use OpenGL debug context

	// Initialize window
	glutInitWindowSize(win_width, win_height);
	glutCreateWindow("PV227 - Tessellation viewer");

	// Initialize GLEW
	glewExperimental = GL_TRUE;
	glewInit();

	// Initialize DevIL library
	InitDevIL();

	// Set the OpenGL debug callback
	SetDebugCallback(simple_debug_callback);

	// Register GLUT callbacks
	glutDisplayFunc(on_display);
	glutReshapeFunc(on_reshape);
	glutTimerFunc(20, on_timer, 0);

	glutKeyboardFunc(on_keyboard_func);
	glutSpecialFunc(on_special_func);
	glutMouseFunc(on_mouse_func);
	glutMotionFunc(on_motion_func);
	glutPassiveMotionFunc(on_passive_motion_func);

	// Initialize OpenGL stuff
	init_gui();
	init_scene();

	// Everything is loaded and prepared, reset the application time
	last_glut_time = glutGet(GLUT_ELAPSED_TIME);
	app_time_ms = 0;

	// Run the main loop
	glutMainLoop();

	// Unload AntTweakBar
	TwTerminate();

	return 0;
}